/**
 *  Author: WangCK
 *  Description:
 *  Created on 2018-04-24 15:46:32.
 *  By Visual Studio Code.
 */
export interface JoinStruct {
    join: string
    one: string
    operator: string
    two: string
    action: "JOIN" | "LEFT JOIN" | "RIGHT JOIN"
}

export interface WhereStruct {
    column: string
    operator: string | number
    value: string | number
}

export interface FindInSetStruct {
    findStr: string | number
    strList: string
}

export interface LikeStruct {
    field: string
    likeStr: string
}

export interface WhereInStruct {
    field: string
    whereIn: Array<string | number>
}

export class Condition {
    public table: string = ''

    public select: Array<string> = []

    public join: Array<JoinStruct> = []

    public joinOnWhere: Map<string, Array<WhereStruct>> = new Map<string, Array<WhereStruct>>()

    public where: Array<WhereStruct> = []

    public orWhere: Array<WhereStruct> = []

    public whereNull: Array<string> = []

    public orWhereNull: Array<string> = []

    public whereNotNull: Array<string> = []

    public orWhereNotNull: Array<string> = []

    public order: Array<string> = []

    public skip: number = undefined

    public take: number = undefined

    public groupBy: string = undefined

    public sql: string = ''

    public findInSet: Array<FindInSetStruct> = []

    public orFindInSet: Array<FindInSetStruct> = []

    public like: Array<LikeStruct> = []

    public orLike: Array<LikeStruct> = []

    public whereIn: Array<WhereInStruct> = []

    public orWhereIn: Array<WhereInStruct> = []

    public clear(): void {
        this.table = ''
        this.select = []
        this.join = []
        this.joinOnWhere = new Map<string, Array<WhereStruct>>()
        this.where = []
        this.orWhere = []
        this.whereNull = []
        this.orWhereNull = []
        this.whereNotNull = []
        this.orWhereNotNull = []
        this.order = []
        this.skip = undefined
        this.take = undefined
        this.groupBy = undefined
        this.sql = ''
        this.findInSet = []
        this.orFindInSet = []
        this.like = []
        this.orLike = []
        this.whereIn = []
        this.orWhereIn = []
    }
}