/**
 *  Author: WangCK
 *  Description:
 *  Created on 2018-04-24 15:46:32.
 *  By Visual Studio Code.
 */
export interface JoinStruct {
    join: string;
    one: string;
    operator: string;
    two: string;
    action: "JOIN" | "LEFT JOIN" | "RIGHT JOIN";
}
export interface WhereStruct {
    column: string;
    operator: string | number;
    value: string | number;
}
export interface FindInSetStruct {
    findStr: string | number;
    strList: string;
}
export interface LikeStruct {
    field: string;
    likeStr: string;
}
export interface WhereInStruct {
    field: string;
    whereIn: Array<string | number>;
}
export declare class Condition {
    table: string;
    select: Array<string>;
    join: Array<JoinStruct>;
    joinOnWhere: Map<string, Array<WhereStruct>>;
    where: Array<WhereStruct>;
    orWhere: Array<WhereStruct>;
    whereNull: Array<string>;
    orWhereNull: Array<string>;
    whereNotNull: Array<string>;
    orWhereNotNull: Array<string>;
    order: Array<string>;
    skip: number;
    take: number;
    groupBy: string;
    sql: string;
    findInSet: Array<FindInSetStruct>;
    orFindInSet: Array<FindInSetStruct>;
    like: Array<LikeStruct>;
    orLike: Array<LikeStruct>;
    whereIn: Array<WhereInStruct>;
    orWhereIn: Array<WhereInStruct>;
    clear(): void;
}
